var debug = require('debug')('vlog-api')

module.exports = function api (options) {
    this.add('section:api,action:login', login)
    this.wrap('section:api,action:login', login_check)
    this.add('section:api,action:logout', logout)
    this.add('section:api,action:register', register)
    
    this.add('init:api', init)
}

function login_check (msg, res) {
    if (!msg.username) return res('No username provided')
    
    return this.prior(msg, res)
}

function login (msg, res) {
    debug('Trying to log in with username: ' + msg.username)
    
    this.act('section:auth,req:login', {
        username: msg.username
    }, res)
}

function logout (msg, res) {
    debug('Logging out of: ' + msg.username)
    
    this.act('section:auth,req:logout', {
        username: msg.username
    }, res)
}

function register (msg, res) {
    debug('Registering with username: ' + msg.username)
    
    this.act('section:auth,req:register', {
        username: msg.username
    }, res)
}

function init (msg, res) {
    this.act('role:web', {
        use: {
            prefix: '/api',
            pin: 'section:api,action:*',
            
            map: {
                login: {
                    POST: true
                },
                
                logout: {
                    POST: true
                },
                
                register: {
                    POST: true
                }
            }
        }
    }, res)
}